#include <hip/hip_runtime.h>
#include <stdexcept>
#include <sstream>

#include "hip_throw_on_error.hpp"

void hip_throw_on_error(hipError_t const err, const char* const func, const char* const file, const int line)
{
    if (err != hipSuccess) {
        std::stringstream ss;
        ss << "HIP Runtime Error at: " << file << ":" << line << std::endl;
        ss << hipGetErrorString(err) << " " << func << std::endl;
        throw std::runtime_error(ss.str());
    }
}
